'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.hasStream = hasStream;
exports.arrayStream = arrayStream;

var _flyd = require('flyd');

function hasStream(array) {
  for (var i = 0; i < array.length; i++) {
    if ((0, _flyd.isStream)(array[i])) return true;
  }
  return false;
}

function evaluateStreams(array) {
  return array.map(function (child) {
    if (!(0, _flyd.isStream)(child)) return child;
    return child();
  });
}

function arrayStream(array) {
  var streams = array.filter(_flyd.isStream);
  return (0, _flyd.combine)(function () {
    return evaluateStreams(array);
  }, streams);
}